// StarPong v 0.95b (c) 1998 Graham Mitchell <mitchell@onr.com> - 22 Nov 1998

// ball.h
// Interface for Ball class

/*
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License (LICENSE.TXT) for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __PONG_BALL_H
#define __PONG_BALL_H

#include "const.h"
#include "queue.cpp"
#include <allegro.h>

const int BALL_UP = 1;
const int BALL_DOWN = 2;
const int BALL_LEFT = 1;
const int BALL_RIGHT = 2;

class Ball
{

public:

	Ball();

	void init();
	void set_bbox(double x1, double y1, double x2, double y2) 
		{ MIN_X=x1; MIN_Y=y1; MAX_X=x2; MAX_Y=y2; }

	void move();
	void vbounce();
	void hbounce();
	void bounce();
	void receive_momentum( double, double, int );
	void score();
	void draw(BITMAP* = screen);

	int touches( BBox );
	int vdirection()
		{ if ( angle >= 0 && angle <= 180 ) return BALL_UP;
		  else return BALL_DOWN; }
	int hdirection()
		{ if ( angle >= 90 && angle <= 270 ) return BALL_LEFT;
		  else return BALL_RIGHT; }
	Point location() { return loc; }

private:

	double dist_sqr(double x1, double y1, double x2, double y2)
	// distance formula
	//	returns non-square rooted value since that saves a lot of math
		{ return ( (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) ); }
	double radius;
	double r_sqr;
	int color;
	Point loc, old;
	double MIN_X, MAX_X, MIN_Y, MAX_Y;
	int speed, angle;

	char str[12];
	bool coord_on;

	Queue<Point> tail;

};

#endif

